export declare type ContextType = {
    Execution: ExecutionContextType;
    State: StateContextType;
    StateMachine: StateMachineContextType;
    Task: TaskContextType;
    Map?: MapContextType;
};
export declare type StateContextType = {
    EnteredTime: string;
    Name: string;
    RetryCount: number;
};
export declare type StateMachineContextType = {
    Id: string;
    Name: string;
};
export declare type TaskContextType = {
    Token: string;
};
export declare type MapContextType = {
    Item: {
        Value: string;
        Index: number;
    };
};
export declare type ExecutionContextType = {
    Id: string;
    Input: string | undefined;
    Name: string;
    RoleArn: string;
    StartTime: string;
};
