import { Context } from '../Context/Context';
import type { StateDefinition } from '../types/State';
import type { StateExecutorOutput } from '../types/StateExecutorOutput';
import { EnvVarResolver } from '../utils/EnvVarResolver';
import { Logger } from '../utils/Logger';
export declare abstract class StateTypeExecutor {
    protected logger: Logger;
    protected envVarResolver: EnvVarResolver;
    constructor();
    abstract execute(context: Context, definition: StateDefinition, inputJson: string | undefined): Promise<StateExecutorOutput>;
    isWaitForTaskToken(resource?: string): boolean;
}
