"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnvVarResolver = void 0;
class EnvVarResolver {
    constructor() { }
    static getInstance() {
        if (!this.INSTANCE) {
            this.INSTANCE = new EnvVarResolver();
        }
        return this.INSTANCE;
    }
    set global(globalEnvironment) {
        this.globalEnvironment = globalEnvironment;
    }
    injectGlobalEnvVars() {
        if (this.globalEnvironment) {
            Object.entries(this.globalEnvironment).forEach(([key, value]) => {
                process.env[key] = value;
            });
        }
    }
    injectEnvVarsLambdaSpecific(lambdaEnv) {
        if (!lambdaEnv) {
            return;
        }
        Object.entries(lambdaEnv).forEach(([key, value]) => {
            process.env[key] = value;
        });
    }
    removeEnvVarsLambdaSpecific(lambdaEnv) {
        if (!lambdaEnv) {
            return;
        }
        Object.keys(lambdaEnv).forEach((key) => {
            if (this.globalEnvironment && key in this.globalEnvironment) {
                process.env[key] = this.globalEnvironment[key];
            }
            else {
                delete process.env[key];
            }
        });
    }
}
exports.EnvVarResolver = EnvVarResolver;
